/************************************************************************
**
** @(#)tterminl.h		10/07/94	Chris Ahlstrom
**
**		Identical to Borland's Turbo Vision file textview.2,
** but I'm trying to fix a bad bug.  "2" is appended to the names of
** the classes.
**
**		TTerminal2 and TTextDevice2 member functions.
**
*************************************************************************/

#if !defined(TTERMINL_h)								// { TTERMINL_h
#define TTERMINL_h

#pragma option -Vo-
#if defined(__BCOPT__)
#pragma option -po-
#endif

#define Uses_TScroller
#include <tv.h>

#include <iostream.h>

#pragma option -Vo-
#if defined( __BCOPT__ )
#pragma option -po-
#endif

class far TRect;
class far TScrollBar;

class TTextDevice2 : public TScroller, public streambuf
{

public:

	TTextDevice2
	(
		const TRect &bounds,
		TScrollBar *ahscrollbar,
		TScrollBar *avscrollbar
	);

	virtual int do_sputn
	(
		const char *s,
		int count
	) = 0;

	virtual int overflow
	(
		int = EOF
	);

};


class far TRect;
class far TScrollBar;

class TTerminal2: public TTextDevice2
{

public:

	friend void genRefs();

	TTerminal2
	(
		const TRect &bounds,
		TScrollBar *ahscrollbar,
		TScrollBar *avscrollbar,
		ushort abufsize
	);
	~TTerminal2();

	virtual int do_sputn
	(
		const char *s,
		int count
	);

	void bufInc
	(
		ushort &val
	);
	Boolean canInsert
	(
		ushort amount
	);
	short calcWidth();						// never defined!

	virtual void draw();

	ushort nextLine
	(
		ushort pos
	);
	ushort prevLines						// defined in ttermpln.asm
	(
		ushort pos,
		ushort lines
	);
	Boolean queEmpty();

protected:

	ushort bufSize;
	char *buffer;
	ushort queFront, queBack;
	void bufDec
	(
		ushort &val
	);

};


#include <iostream.h>
#pragma option -Vo-
#if defined( __BCOPT__ )
#pragma option -po-
#endif


class otstream : public ostream
{

public:

	otstream
	(
		TTerminal2 *
	);

};

#pragma option -Vo.
#if defined( __BCOPT__ )
#pragma option -po.
#endif

#endif													// } TTERMINL_h
